--- old/usr/src/uts/common/inet/ip/ip.c	2014-04-28 16:23:08.299467000 -0400
+++ new/usr/src/uts/common/inet/ip/ip.c	2014-04-28 16:23:08.305481654 -0400
@@ -1498,7 +1498,7 @@
 		/* Compute # of milliseconds since midnight */
 		gethrestime(&now);
 		ts = (now.tv_sec % (24 * 60 * 60)) * 1000 +
-		    now.tv_nsec / (NANOSEC / MILLISEC);
+		    NSEC2MSEC(now.tv_nsec);
 		*tsp++ = htonl(ts);	/* Lay in 'receive time' */
 		*tsp++ = htonl(ts);	/* Lay in 'send time' */
 		BUMP_MIB(&ipst->ips_icmp_mib, icmpOutTimestampReps);
@@ -9117,7 +9117,7 @@
 				/* Compute # of milliseconds since midnight */
 				gethrestime(&now);
 				ts = (now.tv_sec % (24 * 60 * 60)) * 1000 +
-				    now.tv_nsec / (NANOSEC / MILLISEC);
+				    NSEC2MSEC(now.tv_nsec);
 				bcopy(&ts, (char *)opt + off, IPOPT_TS_TIMELEN);
 				opt[IPOPT_OFFSET] += IPOPT_TS_TIMELEN;
 				break;
@@ -9343,7 +9343,7 @@
 				/* Compute # of milliseconds since midnight */
 				gethrestime(&now);
 				ts = (now.tv_sec % (24 * 60 * 60)) * 1000 +
-				    now.tv_nsec / (NANOSEC / MILLISEC);
+				    NSEC2MSEC(now.tv_nsec);
 				bcopy(&ts, (char *)opt + off, IPOPT_TS_TIMELEN);
 				opt[IPOPT_OFFSET] += IPOPT_TS_TIMELEN;
 				break;
@@ -12025,7 +12025,7 @@
 				/* Compute # of milliseconds since midnight */
 				gethrestime(&now);
 				ts = (now.tv_sec % (24 * 60 * 60)) * 1000 +
-				    now.tv_nsec / (NANOSEC / MILLISEC);
+				    NSEC2MSEC(now.tv_nsec);
 				bcopy(&ts, (char *)opt + off, IPOPT_TS_TIMELEN);
 				opt[IPOPT_OFFSET] += IPOPT_TS_TIMELEN;
 				break;
